/***************************************************************************
 *   Copyright (C) 2004, 2005 by Gerd Fleischer                            *
 *   gerdfleischer@web.de                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _MAKEPOPUP_H_
#define _MAKEPOPUP_H_

#define ENC_LOCAL8BIT 0
#define ENC_UTF8 1
#define ENC_LATIN1 2
#define ENC_ASCII 3

#include <libsmbclient.h>

#include <qthread.h>

#include <kcombobox.h>
#include <kdialog.h>
#include <ktextedit.h>
#include <kprocess.h>

#include "makepopup_view.h"

class makePopup;

class readGroupsThread : public QThread
{
    public:
        readGroupsThread(makePopup *owner)
            : threadOwner(owner) {}

        // default destructor

    protected:
        void run();

    private:
        makePopup *threadOwner;
};

class readHostsThread : public QThread
{
    public:
        readHostsThread(makePopup *owner)
            : threadOwner(owner) {}

        // default destructor

    protected:
        void run();

    private:
        makePopup *threadOwner;
};

class makePopup : public makePopup_view
{
    Q_OBJECT

    public:
        makePopup(QWidget *, const char *, const QString &, const QString &, int);
        ~makePopup();

        void readGroupList();
        void readHostList();

    signals:
        void makePopupEnd(QWidget *);

    protected:
        void closeEvent(QCloseEvent *);
        bool eventFilter(QObject *, QEvent *);

    private slots:
        void slotButtonSend();
        void finished();
        void slotGroupboxChanged(const QString &);
        void slotSendCmdExit(KProcess *);

   private:
        void initSmbCtx();
        void sendPopup();

        QString smbclientBin;
        int newMsgEncoding;
        SMBCCTX *smbCtx;
        KProcess *p;
        readHostsThread readHosts;
        readGroupsThread readGroups;
};

#endif // _MAKE_POPUP_H_
