/***************************************************************************
 *   Copyright (C) 2004, 2005 by Gerd Fleischer                            *
 *   gerdfleischer@web.de                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qstring.h>

/**
 * a class to hold a message
 */
class popupMessage
{
    public:
        popupMessage(const QString &paramSender,
                     const QString &paramMachine,
                     const QString &paramIP,
                     const QString &paramTime,
                     const QString &paramText)
            : messageSender(paramSender),
              senderMachine(paramMachine),
              senderIP(paramIP),
              messageTime(paramTime),
              messageText(paramText),
              readStatus(false) {}

        //default destructor

        const QString &sender() { return messageSender; }
        const QString &machine() { return senderMachine; }
        const QString &ip() { return senderIP; }
        const QString &time() { return messageTime; }
        const QString &text() { return messageText; }
        bool isRead() { return readStatus; }
        void setRead() {  readStatus = true; }

    private:
        QString messageSender;
        QString senderMachine;
        QString senderIP;
        QString messageTime;
        QString messageText;
        bool readStatus;
};

